CollaborationUI.bindShareMainButton = function () {
  $("#coviewShareMainBtn").on("click", function (e) {
    e.stopPropagation();
    if ($(".coview_share_dropdown_bar").is(":visible") == true) {
      CollaborationUI.shareDropdownHide();

      if ($(".coview_share_photo_select_bubble").is(":visible") == true) {
        $(".coview_share_photo_select_bubble").slideUp();
      }
    } else {
      $(".coview_share_dropdown_bar").slideDown();
    }
  });
};

CollaborationUI.bindShareCloseButton = function () {
  $("#coviewShareCloseButton").on("click", function (e) {
    coview_api.LeaveRoom();
    $(".coview_share_area").hide();
  });
};

CollaborationUI.bindBodyClockEvent = function () {
  $("body").on("click", function () {
    CollaborationUI.shareDropdownHide();

    if ($(".coview_share_photo_select_bubble").is(":visible") == true) {
      $(".coview_share_photo_select_bubble").slideUp();
    } else {
      $(".coview_share_dropdown_bar").slideDown();
    }
  });
};

CollaborationUI.bindShareRequestButton = function () {
  $(document).on("click", ".coview_share_request", function () {
    console.log("peacekim:: DOMContentLoaded - globalUserInfo", globalUserInfo);
    if ($(this).hasClass(CollaborationTypeKey.VIDEO) == true) {
      globalUserInfo.coWorkType = CollaborationTypeKey.VIDEO;
      $(".coview_share_title_name").text("LIVE");
    } else if ($(this).hasClass(CollaborationTypeKey.CAMERA) == true) {
      globalUserInfo.coWorkType = CollaborationTypeKey.CAMERA;
      $(".coview_share_title_name").text("ライブラリ");
    } else if ($(this).hasClass(CollaborationTypeKey.AUDIO) == true) {
      globalUserInfo.coWorkType = CollaborationTypeKey.AUDIO;
      $(".coview_share_title_name").text("音声通話");
    }

    coview_api.JoinRoom(globalUserInfo.roomId, globalUserInfo.coWorkType);
    CollaborationUI.moveToVideoShareArea();
  });
};

CollaborationUI.bindShareChat = function () {
  $("#coviewShareChat").on("click", function () {
    console.log("peacekim:: ON click coviewShareChat");
  });
};

CollaborationUI.bindSharePhotoTapped = function () {
  $("#coviewSharePhoto").on("click", function (e) {
    e.stopPropagation();
    console.log("peacekim:: ON click coviewSharePhoto");

    if ($(".coview_share_photo_select_bubble").is(":visible") == true) {
      $(".coview_share_photo_select_bubble").slideUp();
    } else {
      $(".coview_share_photo_select_bubble").slideDown();
    }
  });
};

CollaborationUI.bindSharePhotoCameraTapped = function () {
  $("#coviewSharePhotoCamera").on("click", function () {
    $(".coview_share_photo_select_bubble").hide();
    globalUserInfo.coWorkType = CollaborationTypeKey.CAMERA;
    coview_api.CreateRoom(globalUserInfo.roomId, globalUserInfo.coWorkType);
    CollaborationUI.moveToVideoShareArea();

    $(".coview_share_title_name").text("カメラ");
  });
};

CollaborationUI.bindSharePhotoLibraryTapped = function () {
  $("#coviewSharePhotoGallery").on("click", function () {
    $(".coview_share_photo_select_bubble").hide();
    globalUserInfo.coWorkType = "gallery";
    coview_api.CreateRoom(globalUserInfo.roomId, globalUserInfo.coWorkType);
    CollaborationUI.moveToVideoShareArea();

    $(".coview_share_title_name").text("ライブラリ");
  });
};

CollaborationUI.bindShareAudioTapped = function () {
  $("#coviewShareAudio").on("click", function () {
    CollaborationUI.connectAudioCollaboration();
  });
};

CollaborationUI.bindShareLive = function () {
  $("#coviewShareLive").on("click", function () {
    console.log("peacekim:: ON click coviewShareLive");
    globalUserInfo.coWorkType = "video";
    console.log("peacekim:: globalUserInfo", globalUserInfo);

    coview_api.CreateRoom(globalUserInfo.roomId, globalUserInfo.coWorkType);
    CollaborationUI.moveToVideoShareArea();

    $(".coview_share_title_name").text("LIVE");
  });
};

CollaborationUI.shareDropdownHide = function () {
  $(".coview_share_dropdown_bar").slideUp();
  $(".coview_share_photo_select_bubble").slideUp();
};

CollaborationUI.connectAudioCollaboration = function () {
  globalUserInfo.coWorkType = CollaborationTypeKey.AUDIO;
  coview_api.deleteRoom(globalUserInfo.roomId);
  coview_api.CreateRoom(globalUserInfo.roomId, globalUserInfo.coWorkType);
  CollaborationUI.moveToVideoShareArea();
  CollaborationUI.moveToAudioShareArea();
  $(".coview_share_title_name").text("音声通話");
};

CollaborationUI.moveToVideoShareArea = function () {
  $("#loadingIndicator").addClass("full_active");
  $(".coview_share_area").show();
  $("#collabo_main").removeClass("none");
};

CollaborationUI.moveToAudioShareArea = function () {
  $(".coview_share_area").addClass("none");
  $("#collabo_main").removeClass("none");
  $(".talking_area").removeClass("none");
};

function togglePen() {
  $("#coviewPenCtrBtn").click();
  if ($("#penBtn .pen").hasClass("disable")) {
    $("#penBtn .pen").removeClass("disable");
  } else {
    $("#penBtn .pen").addClass("disable");
  }
}

function penOff() {
  if (!$("#penBtn .pen").hasClass("disable")) {
    $("#coviewPenCtrBtn").click();
    $("#penBtn .pen").addClass("disable");
  }
}

function togglePhotoOpenPlaceHolder() {
  $("#open_file_upload").trigger("click");
}

function toggleEraser() {
  $("#coviewEraserCtrBtn").click();
}

function toggleCapture() {
  if ($("#recordBtn").hasClass("bg_red")) {
    screenLock();
    recordStop(function () {
      $("#screenLock").remove();
      coview_api.Capture(serverInfo.cmsURL + "/chatapi/file/uploadArchive");
    });
  } else {
    coview_api.Capture(serverInfo.cmsURL + "/chatapi/file/uploadArchive");
  }
}

function toggleCaptureRequest() {
  fw.sendToMsg("others", "CAPTURE_REQUEST", {
    name: currentUserInfo.loginID,
  });
}

function micOn() {
  coview_api.MicMuteControl("off");
  $("#micBtn .voice").removeClass("disable");
}

function micOff() {
  coview_api.MicMuteControl("on");
  $("#micBtn .voice").addClass("disable");
}

function toggleMic() {
  if ($("#micBtn .voice").hasClass("disable")) {
    micOn();
  } else {
    micOff();
  }
}

/*************
 * レコード関連
 *************/
function recordStart() {
  console.log("peacekim:: レコードを開始しました");
  MainManRecord("on");
  $("#recordBtn .record").addClass("disable");
  $(".flash-txt").addClass("on");
}

function recordFinished() {
  $("#recordBtn .record").removeClass("disable");
  $(".flash-txt").removeClass("on");
  // ロック画面の削除
  deleteDOMObject("screenLock");
}

function toggleRecord() {
  if (!$("#recordBtn .record").hasClass("disable")) {
    recordStart();
  } else {
    recordStop(function () {
      console.log("peacekim:: レコードを終了しました");
    });
  }
}

function recordStop(callback) {
  if (!$("#recordBtn .record").hasClass("disable")) {
    callback();
    return;
  }
  Common.showLoadingIndicator();
  // アーカイブ保存中は画面操作不可(協業終了,協業切り替え防止)
  screenLock();

  // アーカイブ保存処理
  mainManRecordWithCollaboration(
    "stop",
    serverInfo.cmsURL + "/chatapi/file/uploadArchive",
    callback
  );
}

function mainManRecordWithCollaboration(action, url, callback) {
  try {
    mediaRecorder.stop();
  } catch (exeption) {
    console.log("peacekim:: Record fail");
    callback();
  }
  console.log("peacekim:: Recorded Blobs: ", recordedBlobs);

  setTimeout(function () {
    console.log("peacekim:: Recoding File upload..");
    const blob = new Blob(recordedBlobs, { type: "video/webm" });
    const uploadFileName = "record_" + g_webroom + "_" + g_shareCount + ".webm";
    g_shareCount++;
    let formData = new FormData();
    formData.append("fileData", blob, uploadFileName);
    formData.append("sid", globalUserInfo.sid);
    formData.append("roomId", globalUserInfo.roomId);
    if (joinCollaborationType == COLLABORATION_TYPE.VIDEO) {
      formData.append("archiveType", 1);
    } else {
      formData.append("archiveType", 2);
    }
    $.ajax({
      type: "post",
      url,
      data: formData,
      contentType: false,
      processData: false,
      success: function (res) {
        recordFinished();
        Common.dismissLoadingIndicator();
        callback();
      },
      error: function (err) {
        recordFinished();
        Common.dismissLoadingIndicator();
        callback();
      },
    });
  }, 1000);
}
