var CoviewBridge = {};

CoviewBridge.bindReadyEvent = function () {
  coview_api.addEventListener("ready", function () {
    console.log("peacekim:: =============> READY : ready for coview api");
    Coview_addLoginId(globalUserInfo.loginId);
    coview_api.Login(globalUserInfo.loginId);
    initCollaborationUI(joinCollaborationType);
    NativeBridgeDelegate.setHostRequestFlg(HostRequestFlag.DONE);
    fw.socket.on("message", async function (data) {
      console.log("peacekim:: ====> message::data: ", data);
      if (data.type === "CHANGE_COLLABORATION") {
        if (joinCollaborationType == COLLABORATION_TYPE.DOCUMENT) {
          NativeBridgeDelegate.exitMeetingRoom();
          NativeBridgeDelegate.finishPIPMode(true);

          if (deviceInfo.isAndroid()) {
            $(".pip_indicator").addClass("none");
          }

          await new Promise((done) => setTimeout(() => done(), 500));
          updateCanvasSize();
        }

        if (
          deviceInfo.isAndroid() &&
          data.payload.collaborationType == COLLABORATION_TYPE.DOCUMENT &&
          androidVersion < ANDROID_SDK_VERSION.O
        ) {
          coview_api.HeartBeatUser(globalUserInfo.loginId);
          alert(getLocalizedString("not_support_version"));
          joinCollaborationType = COLLABORATION_TYPE.CAMERA;
        } else {
          joinCollaborationType = data.payload.collaborationType;
        }
        joinMeetingId = data.payload.newMeetingId;
        initCollaborationUI(joinCollaborationType);

        NativeBridgeDelegate.joinChangedCollaboration(
          joinCollaborationType,
          data.payload.newMeetingId
        );

        if (joinCollaborationType == COLLABORATION_TYPE.DOCUMENT) {
          NativeBridgeDelegate.joinMeetingRoom(data.payload.newMeetingId);
        }
      } else if (data.type === "SHARE_FILE") {
        if (joinCollaborationType != COLLABORATION_TYPE.CAMERA) {
          initCollaborationUI(COLLABORATION_TYPE.CAMERA);
          joinCollaborationType = COLLABORATION_TYPE.CAMERA;
          fw.sendToMsg("others", "SHARE_FILE_HOST", {
            collaborationType: COLLABORATION_TYPE.CAMERA,
          });
        }
      } else if (data.type === "SHARE_FILE_HOST") {
        if (joinCollaborationType != COLLABORATION_TYPE.CAMERA && g_isMainMan) {
          initCollaborationUI(COLLABORATION_TYPE.CAMERA);
          joinCollaborationType = COLLABORATION_TYPE.CAMERA;
        }
      } else if (data.type === "CAPTURE_REQUEST" && g_isMainMan) {
        if (
          confirm(data.payload.name + getLocalizedString("request_capture"))
        ) {
          if ($("#recordBtn .record").hasClass("disable")) {
            screenLock();
            recordStop(function () {
              $("#screenLock").remove();
              captureAndShareImage(
                serverInfo.cmsURL + "/chatapi/file/uploadArchive",
                data.payload.name
              );
            });
          } else {
            captureAndShareImage(
              serverInfo.cmsURL + "/chatapi/file/uploadArchive",
              data.payload.name
            );
          }
        }
      } else if (data.type === "HOST_CHANGE_REQUEST") {
        if (data.payload.loginId == globalUserInfo.loginId) {
          fw.sendToMsg("others", "HOST_CHANGE_RESPONSE", {
            isAndroid: deviceInfo.isAndroid(),
            isAble: androidVersion >= ANDROID_SDK_VERSION.O,
            loginId: currentUserInfo.loginID,
          });
        }
      } else if (data.type === "HOST_CHANGE_RESPONSE") {
        var isAndroid = data.payload.isAndroid;
        var isAble = data.payload.isAble;
        if (
          g_isMainMan &&
          isAndroid &&
          !isAble &&
          joinCollaborationType == COLLABORATION_TYPE.DOCUMENT
        ) {
          coview_api.HeartBeatUser(globalUserInfo.loginId);
          alert(getLocalizedString("err_target_android_version_not_support"));
        } else if (g_isMainMan) {
          fw.sendToMsg("others", "PIP_END_REQUEST", {
            loginId: getFermiLoginId(data.payload.loginId),
          });
          await new Promise((done) => setTimeout(() => done(), 500));
          Coview_changeHost(getFermiLoginId(data.payload.loginId));
        }
      } else if (data.type === "PIP_END_REQUEST") {
        if (
          data.payload.loginId == globalUserInfo.loginId &&
          joinCollaborationType == COLLABORATION_TYPE.DOCUMENT
        ) {
          NativeBridgeDelegate.finishPIPMode(true);
          if (deviceInfo.isAndroid()) {
            $(".pip_indicator").addClass("none");
          }
        }
      } else if (data.type === "API_SEND_OWNER_CHANGE_COMPLETE") {
        penOff();
        if ($("#recordBtn .record").hasClass("disable")) {
          recordStop(function () {
            console.log("peacekim:: ホスト変更によりレコードを終了しました");
          });
        }
        if ($("#micBtn .voice").hasClass("disable")) {
          micOff();
        } else {
          micOn();
        }
      } else if (data.type === "API_SEND_OWNER_CHANGE_CONFIRM") {
        if (joinCollaborationType == COLLABORATION_TYPE.CAMERA) {
          await new Promise((done) => setTimeout(() => done(), 500));
          removeOldLocalVideo(g_localStream);
        }
      } else if (data.type === "CHANGE_HOST_APPLY") {
        if (g_isMainMan) {
          coview_api.HeartBeatUser(globalUserInfo.loginId);
          NativeBridgeDelegate.finishPIPMode(true);
          if (deviceInfo.isAndroid()) {
            $(".pip_indicator").addClass("none");
          }
        }

        NativeBridgeDelegate.setHostRequestFlg(HostRequestFlag.DOING);

        await new Promise((done) => setTimeout(() => done(), 500));
        if (g_isMainMan) {
          if (
            confirm(
              getLocalizedString(
                "norify_request_host_change",
                data.payload.hostId
              )
            )
          ) {
            Coview_changeHost(getFermiLoginId(data.payload.hostId));
            NativeBridgeDelegate.setHostRequestFlg(HostRequestFlag.DONE);
          } else {
            fw.sendToMsg("others", "HOST_REQUEST_REJECT", {
              hostId: data.payload.hostId,
            });
          }
          fw.sendToMsg("others", "HOST_REQUEST_DONE", {
            hostId: data.payload.hostId,
          });
        }
      } else if (data.type === "HOST_REQUEST_DONE") {
        NativeBridgeDelegate.setHostRequestFlg(HostRequestFlag.DONE);
      } else if (data.type === "HOST_REQUEST_REJECT") {
        if (data.payload.hostId == currentUserInfo.loginID) {
          alert("REJECT for owner user");
        }
        NativeBridgeDelegate.setHostRequestFlg(HostRequestFlag.DONE);
      } else if (data.type === "GET_COLLABORATION_TYPE" && g_isMainMan) {
        fw.sendToMsg("others", "GET_COLLABORATION_TYPE_RESPONSE", {
          loginId: data.payload.loginId,
          collaborationType: joinCollaborationType,
          newMeetingId: joinMeetingId,
        });
      } else if (data.type === "GET_COLLABORATION_TYPE_RESPONSE") {
        console.log("peacekim:: t1 " + data.payload.newMeetingId);
        if (data.payload.loginId == globalUserInfo.loginId) {
          if (
            deviceInfo.isAndroid() &&
            data.payload.collaborationType == COLLABORATION_TYPE.DOCUMENT &&
            androidVersion < ANDROID_SDK_VERSION.O
          ) {
            coview_api.HeartBeatUser(globalUserInfo.loginId);
            alert(getLocalizedString("not_support_version"));
            joinCollaborationType = COLLABORATION_TYPE.CAMERA;
          } else {
            joinCollaborationType = data.payload.collaborationType;
          }
          joinMeetingId = data.payload.newMeetingId;
          initCollaborationUI(joinCollaborationType);

          NativeBridgeDelegate.joinChangedCollaboration(
            joinCollaborationType,
            data.payload.newMeetingId
          );

          if (joinCollaborationType == COLLABORATION_TYPE.DOCUMENT) {
            NativeBridgeDelegate.joinMeetingRoom(data.payload.newMeetingId);
          }
        }
      } else if (data.type === "API_WELCOME") {
        if (collaborationJoinFlg == "2") {
          fw.sendToMsg("others", "GET_COLLABORATION_TYPE", {
            loginId: globalUserInfo.loginId,
          });
          collaborationJoinFlg = "1";
          isInvited = InvitedFlag.INVITED;
        }
      }
    });
  });
};

CoviewBridge.bindStartEvent = function () {
  coview_api.addEventListener("start", function () {
    console.log("peacekim:: =============> START : share start");
    scrollLockON();
    $("#loadingIndicator").removeClass("full_active");
  });
};

CoviewBridge.bindAllByeEvent = function () {
  coview_api.addEventListener("allbye", function () {
    requestCollaborationFinish();
    var isDocument = false;
    if (joinCollaborationType == COLLABORATION_TYPE.DOCUMENT) {
      isDocument = true;
    }
    if (deviceInfo.isAndroid()) {
      android.setExitHostAlert();
    }
    if (isDocument) {
      NativeBridgeDelegate.exitMeetingRoom();
    }
    if (isInvited == InvitedFlag.NONE) {
      NativeBridgeDelegate.joinRoom(roomInfo.roomID, roomInfo.roomName);
    } else {
      NativeBridgeDelegate.openCommunicationHome();
    }
    console.log("peacekim:: =============> HOST BYE : share hostbye");
    // TODO: peacekim:: check not to need this method for android
    if (deviceInfo.isiOS()) {
      NativeBridgeDelegate.showExitHostAlert();
      return;
    }
    $("#loadingIndicator").removeClass("full_active");
  });
};

CoviewBridge.bindGuestByeEvent = function () {
  coview_api.addEventListener("guestbye", function () {
    console.log(" peacekim::=============> GUEST BYE : share guestbye");
    $("#loadingIndicator").removeClass("full_active");
  });
};

CoviewBridge.bindDestroyEvent = function () {
  coview_api.addEventListener("destroy", function () {
    requestCollaborationFinish();
    console.log("peacekim:: =============> DESTROY : share destroy");
    alert(getLocalizedString("inform_exit_host_collaboration"));
    var isDocument = false;
    if (joinCollaborationType == COLLABORATION_TYPE.DOCUMENT) {
      isDocument = true;
    }
    Coview_exitCollaboration(isDocument);
    $("#loadingIndicator").removeClass("full_active");
  });
};

CoviewBridge.bindMessageEvent = function () {
  let meetingId;
  coview_api.addEventListener("message", async function (event, json) {
    console.log("peacekim:: +++ addEventListener", json);
    console.log("peacekim:: processMessage api = ", json.api);
    if (isLeaved) return;
    let loginIdList = new Array();
    switch (json.api) {
      case "LoginResponse":
        if (globalUserInfo.coWorkType == CollaborationTypeKey.DOCUMENT) {
          isDocument = true;
          globalUserInfo.coWorkType = CollaborationTypeKey.AUDIO;
        }
        if (globalUserInfo.coWorkType == CollaborationTypeKey.BOARD) {
          isBoard = true;
          globalUserInfo.coWorkType = CollaborationTypeKey.AUDIO;
        }
        hostSearchInterval();
        if (collaborationJoinFlg == "1") {
          coview_api.JoinRoom(globalUserInfo.roomId, globalUserInfo.coWorkType);
          if (isDocument) {
            NativeBridgeDelegate.startContentView();
          }
        } else if (collaborationJoinFlg == "0") {
          let deleteRoomResult = JSON.parse(
            await deleteRoomApi(globalUserInfo.roomId)
          );
          if (deleteRoomResult.resultCode == 200) {
            await new Promise((done) => setTimeout(() => done(), 3000));
          }
          coview_api.CreateRoom(
            globalUserInfo.roomId,
            globalUserInfo.coWorkType
          );
          if (isDocument) {
            meetingId = NativeBridgeDataSource.createContentView();
            joinMeetingId = meetingId;
          }
        } else if (collaborationJoinFlg == "2") {
          isInvited = InvitedFlag.INVITED;
          coview_api.JoinRoom(globalUserInfo.roomId, globalUserInfo.coWorkType);
        }
        CollaborationUI.moveToVideoShareArea();

        break;
      case "CreateRoomResponse":
        if (json.resultCode == 200) {
          var coviewInviteMessage;
          if (isDocument) {
            coviewInviteMessage =
              "" +
              messageSeperator +
              MessageType.COMMUNICATIONSTART +
              messageSeperator +
              CHAT_UTIL.getCollaborationType(CollaborationTypeKey.DOCUMENT) +
              messageSeperator +
              meetingId;
          } else if (isBoard) {
            coviewInviteMessage =
              "" +
              messageSeperator +
              MessageType.COMMUNICATIONSTART +
              messageSeperator +
              COLLABORATION_TYPE.BOARD;
          } else {
            coviewInviteMessage =
              "" +
              messageSeperator +
              MessageType.COMMUNICATIONSTART +
              messageSeperator +
              CHAT_UTIL.getCollaborationType(globalUserInfo.coWorkType);
          }
          CHAT_SOCKET.emitCreateMessage(coviewInviteMessage, 0);
        }
        break;
      case "joinRoomInfoResponse":
        if (json.resultCode == 200) {
        } else {
          alert(getLocalizedString("not_exist_sharing_call"));
          coview_api.LeaveRoom();
          $(".coview_share_area").hide();
          $("#loadingIndicator").removeClass("full_active");
          NativeBridgeDelegate.joinRoom(roomInfo.roomID, roomInfo.roomName);
        }
        break;
      case "JoinRoomResponse":
        if (json.resultCode == 200) {
          hostSearchInterval();
          for (let key in g_participants) {
            loginIdList.push(key);
          }
          CollaborationUI.refreshJoinedCollaboration(loginIdList);
        } else {
        }
        break;
      case "RoomMemberJoinedEvent":
        for (let key in g_participants) {
          loginIdList.push(key);
        }
        CollaborationUI.refreshJoinedCollaboration(loginIdList);
        break;
      case "RoomMemberLeavedEvent":
        for (let key in g_participants) {
          loginIdList.push(key);
        }
        CollaborationUI.refreshJoinedCollaboration(loginIdList);
        break;
      case "HostRequest":
        // to be called by
        // wc_api.dispatchEvent (new Event ("message"), {"HostRequest":"userID"});
        console.log("peacekim:: t2 consoleLog", json);
        break;
      case "fileChange":
        if (joinCollaborationType != COLLABORATION_TYPE.CAMERA) {
          break;
        }
        LoadMobileShareFile(json.fileName);
        backgroundFileName = json.fileName;
        console.log("peacekim:: fileChange", json);
        break;
      case "ReceiveMediaResponse":
        if (isBoard && g_isMainMan) {
          wc_api.dispatchEvent(new Event("message"), {
            api: "fileChange",
            fileName: backgroundFileName,
          });
        }
        break;
      default:
        console.log("peacekim:: Unrecognized api", json);
        break;
    }
  });
};

function Coview_changeHost(userId) {
  console.log("peacekim:: Change Host To " + userId);
  changeOwnerSend(userId);
}

function Coview_addLoginId(loginId) {
  console.log("peacekim:: addUser loginId = " + loginId);
  const url = "https://biztaskyell.abookcloud.com/auth/getuser";
  $.ajax({
    url: url,
    method: "post",
    data: {
      id: loginId,
    },
    success: function (result) {
      console.log("peacekim:: t3 result", result);
      if (result.statusCode != 200) {
        coview_api.addUser(loginId);
      }
    },
    error: function (err) {
      console.log(err.toString());
    },
  });
}

function hostSearchInterval() {
  let hostName = "";
  function hostSearch() {
    if (g_isMainMan) {
      $("#collaboration_user_" + currentUserInfo.loginID).addClass("host");
      $(".host_contents").removeClass("none");
      if (joinCollaborationType == COLLABORATION_TYPE.CAMERA) {
        $(".photo_select_button").removeClass("none");
      }
      if (joinCollaborationType == COLLABORATION_TYPE.VIDEO) {
        $(".video_contents_host").removeClass("none");
        $(".video_contents_user").addClass("none");
      }
      if (deviceInfo.isiOS()) isIos = true;
    } else {
      $("#collaboration_user_" + currentUserInfo.loginID).removeClass("host");
      $(".host_contents").addClass("none");
      if (joinCollaborationType == COLLABORATION_TYPE.CAMERA) {
        $(".photo_select_button").addClass("none");
      }
      if (joinCollaborationType == COLLABORATION_TYPE.VIDEO) {
        $(".video_contents_user").removeClass("none");
        $(".video_contents_host").addClass("none");
      }
    }
    if (hostName != g_isMainManUsername) {
      if (hostName != "") {
        $("#collaboration_user_" + getReplacedLoginId(hostName)).removeClass(
          "host"
        );
      }
      $(
        "#collaboration_user_" + getReplacedLoginId(g_isMainManUsername)
      ).addClass("host");
      hostName = g_isMainManUsername;
    } else {
      if (hostName == "") {
        if (
          !$("#collaboration_user_" + currentUserInfo.loginID).hasClass(
            "host"
          ) &&
          coview_api.getRoomUsers()
        ) {
          $("#collaboration_user_" + currentUserInfo.loginID).addClass("host");
        }
      } else {
        if (
          !$("#collaboration_user_" + getReplacedLoginId(hostName)).hasClass(
            "host"
          )
        ) {
          $("#collaboration_user_" + getReplacedLoginId(hostName)).addClass(
            "host"
          );
        }
      }
    }
  }
  timeInterval = setInterval(hostSearch, 2000);
}

function captureAndShareImage(urls, changeHostName) {
  addCaptureEffect();
  $(this).removeClass("on");
  var w, h;
  const video = document.getElementById("localVideo");
  const canvas = document.createElement("canvas");
  if (clientOrientaionState == 1) {
    canvas.width = w = 680;
    canvas.height = h = 515;
  } else {
    canvas.width = w = 386;
    canvas.height = h = 515;
  }
  if (canvas.getContext) {
    const ctx = canvas.getContext("2d");
    ctx.drawImage(video, 0, 0, w, h);
    ctx.drawImage(document.getElementById("canvasRemote"), 0, 0, w, h);
  }

  canvas.toBlob(function (blob) {
    var newImg = document.createElement("img");
    var url = URL.createObjectURL(blob);
    canvasRemote.style.backgroundImage =
      "url('" + URL.createObjectURL(blob) + "')";
    canvasRemote.style.backgroundSize = "contain";
    $(canvasRemote).attr(
      "height",
      $(snapshots[cpatureViewIndex]).attr("height")
    );
    $(canvasRemote).attr("width", $(snapshots[cpatureViewIndex]).attr("width"));
    console.log("peacekim:: t5 url", URL.createObjectURL(blob));
    if (
      $(".canvas_wrap").css("width").replace("px", "") /
        $(".canvas_wrap").css("height").replace("px", "") <
      $(canvas).attr("width") / $(canvas).attr("height")
    ) {
      var h =
        $(".canvas_wrap").css("width").replace("px", "") *
        ($(canvas).attr("height") / $(canvas).attr("width"));
      var w = $(".canvas_wrap").css("width").replace("px", "");
      $(canvasRemote).css("height", h);
      $(canvasRemote).css("width", w);
      $(canvasRemote).css("margin-top", -h / 2);
      $(canvasRemote).css("margin-left", -w / 2);
    } else {
      var h = $(".canvas_wrap").css("height").replace("px", "");
      var w =
        $(".canvas_wrap").css("height").replace("px", "") /
        ($(canvas).attr("height") / $(canvas).attr("width"));
      $(canvasRemote).css("height", h);
      $(canvasRemote).css("width", w);
      $(canvasRemote).css("margin-top", -h / 2);
      $(canvasRemote).css("margin-left", -w / 2);
    }
    $(".canvas_wrap").css("background-color", "#000");
    $(".clear_img").show();
    SetShareMenuState("on");
    WithImageShareBtnState("on");

    //Fermi側にイメージ保存。
    var formData = new FormData();
    var uploadFileName =
      "capture_share_" + g_webroom + "_" + g_shareCount + ".png";
    g_shareCount++;
    formData.append("imgFile", blob, uploadFileName);

    var uploadUrl =
      location.protocol +
      "//" +
      location.hostname +
      ":" +
      location.port +
      "/upload/create";
    if (!location.port) {
      uploadUrl =
        location.protocol + "//" + location.hostname + "/upload/create";
    }
    $.ajax({
      type: "post",
      url: g_coviewapiserverADDR + "/upload/create",
      data: formData,
      processData: false,
      contentType: false,
      success: function (res) {
        setTimeout(function () {
          SendFileShare(uploadFileName);
          $("#coviewCaptureCtrBtn").hide();
          $("#coviewRecCtrBtn").hide();
          $(".coview_share_title_name").text("LIVE(CAPTURE IMAGE)");
          $(".coview_on_media_btn_back").show();
          //アーカイブ保存。
          ArchiveFileManage(blob, uploadFileName, urls);
        }, 1500);
      },
      error: function (err) {
        console.log(err);
      },
    });
  });
}

function getReplacedLoginId(loginId) {
  return loginId.replaceAll(globalUserInfo.shopName + "_", "");
}


function Coview_exitCollaboration(isDocument = false) {
  scrollLockOFF();
  if (g_isMainMan) {
    requestCollaborationFinish();
  }
  if (isDocument) {
    NativeBridgeDelegate.exitMeetingRoom();
  }
  if ($("#recordBtn .record").hasClass("disable")) {
    recordStop(Coview_finishCollaboration);
  } else {
    Coview_finishCollaboration();
  }
}

function Coview_finishCollaboration() {
  clearInterval(timeInterval);
  coview_api.LeaveRoom();
  NativeBridgeDelegate.finishCollaboration(true);
  if (coview_api.getRoomUsers()) {
    NativeBridgeDelegate.finishCollaboration();
  }
  isLeaved = true;
  if (isInvited == InvitedFlag.NONE) {
    NativeBridgeDelegate.joinRoom(roomInfo.roomID, roomInfo.roomName);
  } else {
    NativeBridgeDelegate.openCommunicationHome();
  }
}
