/* --------------------------------------------------- */
/* Functions                                           */
/* --------------------------------------------------- */
let coview_api = new CoviewApi();
var isDocument = false;
var isBoard = false;
let isLeaved = false;
let timeInterval = null;
var backgroundFileName;
var isIos;

document.addEventListener("DOMContentLoaded", function () {
  coview_api.Init({
    coview_api_srv_addr: "https://biztaskyell.abookcloud.com",
    coview_wrap_id: "coviewShare",
    coview_api_key: "8dda7092c5820d663",
  });

  // special button IN Chat ui
  CollaborationUI.bindShareMainButton();

  CollaborationUI.bindShareCloseButton();

  CollaborationUI.bindBodyClockEvent();

  CollaborationUI.bindShareRequestButton();

  /* --------------------------------------------------- */
  /* Video, photo, chat, doc                             */
  /* --------------------------------------------------- */
  CollaborationUI.bindShareChat();

  CollaborationUI.bindSharePhotoTapped();

  CollaborationUI.bindSharePhotoCameraTapped();

  CollaborationUI.bindSharePhotoLibraryTapped();

  CollaborationUI.bindShareAudioTapped();

  CollaborationUI.bindShareLive();
  // todo: peacekim::
  CoviewBridge.bindReadyEvent();

  CoviewBridge.bindStartEvent();

  CoviewBridge.bindAllByeEvent();

  CoviewBridge.bindGuestByeEvent();

  CoviewBridge.bindDestroyEvent();

  CoviewBridge.bindMessageEvent();
});

// call from collaboration_overlay_menu.html and collaboration.html
function changeCollaboration(changeCollaborationType) {
  recordStop(function () {
    var newMeetingId = 0;
    if (joinCollaborationType == COLLABORATION_TYPE.DOCUMENT) {
      NativeBridgeDelegate.exitMeetingRoom();
    }
    NativeBridgeDelegate.setJoinCollaborationType(
      changeCollaborationType,
      androidVersion
    );

    joinCollaborationType = changeCollaborationType;
    initCollaborationUI(changeCollaborationType);
    switch (changeCollaborationType) {
      case COLLABORATION_TYPE.AUDIO:
        coview_api.ChangeCollaboration("audio");
        break;
      case COLLABORATION_TYPE.CAMERA:
        removeOldLocalVideo(g_localStream);
        coview_api.ChangeCollaboration("image");
        break;
      case COLLABORATION_TYPE.VIDEO:
        coview_api.ChangeCollaboration("video");
        break;
      case COLLABORATION_TYPE.DOCUMENT:
        coview_api.ChangeCollaboration("audio");
        newMeetingId = NativeBridgeDataSource.createContentView();
        break;
      case COLLABORATION_TYPE.BOARD:
        coview_api.ChangeCollaboration("audio");
        break;
    }

    if ($("#micBtn .voice").hasClass("disable")) {
      micOff();
    } else {
      micOn();
    }

    NativeBridgeDelegate.changeCollaboration(
      changeCollaborationType,
      newMeetingId
    );

    joinMeetingId = newMeetingId;
    fw.sendToMsg("others", "CHANGE_COLLABORATION", {
      collaborationType: changeCollaborationType,
      newMeetingId: newMeetingId,
    });
  });
}

var scrollLock = function (e) {
  if (deviceInfo.isiOS()) {
    if (
      $(e.target).closest(".add_user_modal").length > 0 ||
      $(e.target).closest("#overlay_user_list").length > 0 ||
      $(e.target).closest(".pip_indicator").length > 0
    ) {
      e.stopPropagation();
    } else {
      e.preventDefault();
    }
  }
};

let collaboScreen = document.getElementById("collabo_main");

function scrollLockON() {
  collaboScreen.addEventListener("touchmove", scrollLock, { passive: false });
}

function scrollLockOFF() {
  collaboScreen.removeEventListener("touchmove", scrollLock, {
    passive: false,
  });
}

async function initCollaborationUI(changeCollaborationType) {
  $("#coviewEraserCtrBtn").click();
  if ($(".user_btn").hasClass("hide")) {
    $(".user_btn").click();
  }
  if ($(".menu_btn").hasClass("hide")) {
    $(".menu_btn").click();
  }
  const roomType = NativeBridgeDataSource.getRoomType();
  if (roomType == ChatRoomType.DM) {
    $(".add_user_btn").removeClass("none");
  }

  $("link[href='./css/collaboration_board.css']").remove();

  switch (changeCollaborationType) {
    case COLLABORATION_TYPE.AUDIO:
      $(".collaboration_contents").addClass("none");
      $(".voice_contents").removeClass("none");
      break;
    case COLLABORATION_TYPE.CAMERA:
      $(".collaboration_contents").addClass("none");
      $(".picture_contents").removeClass("none");
      break;
    case COLLABORATION_TYPE.VIDEO:
      $(".collaboration_contents").addClass("none");
      $(".video_contents").removeClass("none");
      break;
    case COLLABORATION_TYPE.DOCUMENT:
      $(".collaboration_contents").addClass("none");
      $(".document_contents").removeClass("none");
      break;
    case COLLABORATION_TYPE.BOARD:
      $(".collaboration_contents").addClass("none");
      $(".board_contents").removeClass("none");
      $("head").append(
        '<link rel="stylesheet" href="./css/collaboration_board.css">'
      );
      break;
  }
  await waitMillisecond(1000);
  $(".before_loading_indicator").addClass("none");
}

// call from modal_collabo_host_request.html
function applyForHostChange() {
  if (
    joinCollaborationType == COLLABORATION_TYPE.DOCUMENT &&
    androidVersion < ANDROID_SDK_VERSION.O &&
    deviceInfo.isAndroid()
  ) {
    alert(getLocalizedString("not_support_version"));
    return;
  }
  const hostRequestFlg = NativeBridgeDataSource.getHostRequestFlg();
  if (hostRequestFlg == HostRequestFlag.DOING) {
    alert(getLocalizedString("already_processing_host_request"));
    return;
  }

  NativeBridgeDelegate.setHostRequestFlg(HostRequestFlag.DOING);

  fw.sendToMsg("others", "CHANGE_HOST_APPLY", {
    hostId: currentUserInfo.loginID,
  });
}

// call from modal_collabo_profile.html
function hostChangeRequest(loginId) {
  fw.sendToMsg("others", "HOST_CHANGE_REQUEST", {
    loginId: getFermiLoginId(loginId),
  });
}

function getFermiLoginId(loginId) {
  return globalUserInfo.shopName + "_" + loginId;
}

function screenLock() {
  // ロック用のdivを生成
  const element = document.createElement("div");
  element.id = "screenLock";

  // ロック用のスタイル
  element.style.height = "100%";
  element.style.left = "0px";
  element.style.position = "fixed";
  element.style.top = "0px";
  element.style.width = "100%";
  element.style.zIndex = "9999";
  element.style.opacity = "0";

  const objBody = document.getElementsByTagName("body").item(0);
  objBody.appendChild(element);
}

// div削除関数
function deleteDOMObject(id_name) {
  const dom_obj = document.getElementById(id_name);
  const dom_obj_parent = dom_obj.parentNode;
  dom_obj_parent.removeChild(dom_obj);
}

function requestCollaborationFinish() {
  if (socket != null && socket.connected) {
    const sendData = DATA_MESSAGE_SCHEME + FINISH_ALL_COLLABORATION_SIGNAL;
    CHAT_SOCKET.emitCreateMessage(sendData, 0);
  }
}

async function waitMillisecond(millesecond) {
  await new Promise((done) => setTimeout(() => done(), millesecond));
}
